##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
##############################################################################
package p3_memo;
use p3_ses;
use p3_conf;
use p3_uti;
use Exporter;
@ISA    = qw( Exporter );
@EXPORT = qw( main );
use strict;

sub main
{
  my    $act = $SDA{ "in_act" };
  if    ( $act eq "form" )   { form_item()   }
  elsif ( $act eq "update" ) { update_item() }
  elsif ( $act eq "delete" ) { delete_item() }
  elsif ( $act eq "view" )   { view_item()   }
  else  { list_items() }
};

##############################################################################

sub form_item
{
  my $text;
  
  my $id = $SDA{ "in_id" };
  
  my %data = ();
  
  load_hash( $id, %data );
  
  my @td;

  my $cats_list = get_cats_option_list( $data{ category } );
  
  push @td, [ "<b>Title:", 
              "<input name=title value='$data{title}' size=52>" ];
  push @td, [ "<b>Category:", 
              "<b><select name=category><option>Unified</option>$cats_list</select>" ];
  push @td, [ "<b>Note:", 
              "<textarea name=note rows=10 cols=50>$data{note}</textarea>" ];

  my $cancel = $id == 0 ? "act=list" : "act=view&id=$id";
  $text .= "
    <center>
    <form action=$SCR?>
    <input type=hidden name=id   value=$id>
    <input type=hidden name=act  value=update>"
    . fmt_table2( @td, { width => "80%", 
                         right1 => "hack",
                         cellpadding => 1 } ) .
    "
    <hr noshade size=1 width=80%>
    <-subimg:done>
    <a href='$SCR?$cancel'><-img:cancel></a>
    <a href='$SCR?act=delete&id=$id'><-img:delete></a>
    </form>
    ";

  return $text;
};

##############################################################################

sub update_item
{
  my $id = $SDA{ "in_id" };
  $id = new_id() if $id == 0;

  my %data;
  for( qw( title category note ) )
    {
    $data{ $_ } = $SDA{ "in_$_" };
    }
  $data{ "find_title" } = $data{ title }; # see find module notes!
  save_hash( $id, %data );

  $SDA{ "in_id" } = $id;
  return view_item();
};

##############################################################################

sub delete_item
{
  my $id = $SDA{ "in_id" };
  system( "mv $id deleted/$id" );
  return list_items();
};

##############################################################################

sub list_items
{
  my $text;

  my @td;
  push @td, [ "<b>Size", "+<b>Title" ];
  
  while(<[0-9]*>)
    {
    my $id = $_;
    my %data;
    load_hash( $id, %data );

    my $cat_link;
    if ( $CAT ne "All" )
      {
      if ( $data{ category } ne $CAT ) { next };
      }
    else
      {
      my $cat_e = CGI::escape( $data{ category } );
      $cat_link = "&nbsp;&nbsp;<font size=-1>(<a href=$SCR?act=list&cat=$cat_e>$data{ category }</a>)</font>";
      }  

    my $note_reminder = rtf_note_reminder( $data{note} );

    my $size = length( $data{note} );

    push @td, [ "<b>$size</b>", 
                "<a href=$SCR?act=view&id=$id><b>$data{title}</b></a>$cat_link
                 <font size=-1>$note_reminder</font>" ];
    }

  $text .= fmt_table( @td ) . "
    <p>
    <hr noshade size=1 width=80%>
    <center>
    <a href=$SCR?act=form&id=0><-img:new></a>
    </center>
  ";

  return $text;
};

##############################################################################

sub view_item
{
  my $text;
  
  my $id = $SDA{ "in_id" };
  
  my %data;
  load_hash( $id, %data );

  my $notes = rtf_text( $data{note} );

  my @td;
  
  push @td, [ "<b>Title: $data{title}</b>", 
              "<b>Category: $data{category}</b>" ];
  push @td, [ "=<pre>$notes</pre>" ];

  $text .= "<center>" . fmt_table( @td, { width => "80%" } ) . 
   "<hr noshade size=1 width=80%>
    <a href='$SCR?act=list'><-img:cancel></a>
    <a href='$SCR?act=form&id=$id'><-img:edit></a>
    </center>
    ";

  return $text;
};

1;
